=== examples/arrayfire/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "arrayfire")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

find_package(LAPACK QUIET)
find_package(Boost QUIET)

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE GIT_REPOSITORY "https://github.com/arrayfire/arrayfire.git")
else()
  set(FETCH_SOURCE URL "https://github.com/arrayfire/arrayfire/archive/v3.6.1.tar.gz")
endif()

if(HAVE_GIT)

if(LAPACK_FOUND AND
   Boost_FOUND AND (NOT Boost_VERSION VERSION_LESS "1.48"))

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    ${FETCH_SOURCE}
    #PATCH_COMMAND  pwd && sed -i "s/CL_DEVICE_TYPE_GPU/CL_DEVICE_TYPE_CPU/g" *.cpp
    #UPDATE_COMMAND /bin/true
    CMAKE_ARGS
      -DBUILD_GRAPHICS=OFF
      -DBUILD_CUDA=OFF
      -DBUILD_CPU=OFF
      -DBUILD_OPENCL=ON
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      "-DCMAKE_C_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME arrayfire_tests_approx1_opencl
           COMMAND "${TS_BUILDDIR}/test/approx1_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_approx2_opencl
           COMMAND "${TS_BUILDDIR}/test/approx2_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_array_opencl
           COMMAND "${TS_BUILDDIR}/test/array_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_assign_opencl
           COMMAND "${TS_BUILDDIR}/test/assign_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_backend_opencl
           COMMAND "${TS_BUILDDIR}/test/backend_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_basic_c_opencl
           COMMAND "${TS_BUILDDIR}/test/basic_c_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_basic_opencl
           COMMAND "${TS_BUILDDIR}/test/basic_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_bilateral_opencl
           COMMAND "${TS_BUILDDIR}/test/bilateral_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_binary_opencl
           COMMAND "${TS_BUILDDIR}/test/binary_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_blas_opencl
           COMMAND "${TS_BUILDDIR}/test/blas_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_cholesky_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/cholesky_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_complex_opencl
           COMMAND "${TS_BUILDDIR}/test/complex_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_constant_opencl
           COMMAND "${TS_BUILDDIR}/test/constant_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_convolve_opencl
           COMMAND "${TS_BUILDDIR}/test/convolve_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_corrcoef_opencl
           COMMAND "${TS_BUILDDIR}/test/corrcoef_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_covariance_opencl
           COMMAND "${TS_BUILDDIR}/test/covariance_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diagonal_opencl
           COMMAND "${TS_BUILDDIR}/test/diagonal_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diff1_opencl
           COMMAND "${TS_BUILDDIR}/test/diff1_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_diff2_opencl
           COMMAND "${TS_BUILDDIR}/test/diff2_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_dog_opencl
           COMMAND "${TS_BUILDDIR}/test/dog_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_dot_opencl
           COMMAND "${TS_BUILDDIR}/test/dot_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fast_opencl
           COMMAND "${TS_BUILDDIR}/test/fast_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_large_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_large_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fft_real_opencl
           COMMAND "${TS_BUILDDIR}/test/fft_real_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_fftconvolve_opencl
           COMMAND "${TS_BUILDDIR}/test/fftconvolve_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_flat_opencl
           COMMAND "${TS_BUILDDIR}/test/flat_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_flip_opencl
           COMMAND "${TS_BUILDDIR}/test/flip_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gaussiankernel_opencl
           COMMAND "${TS_BUILDDIR}/test/gaussiankernel_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gen_assign_opencl
           COMMAND "${TS_BUILDDIR}/test/gen_assign_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gen_index_opencl
           COMMAND "${TS_BUILDDIR}/test/gen_index_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_getting_started_opencl
           COMMAND "${TS_BUILDDIR}/test/getting_started_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gfor_opencl
           COMMAND "${TS_BUILDDIR}/test/gfor_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_gradient_opencl
           COMMAND "${TS_BUILDDIR}/test/gradient_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_hamming_opencl
           COMMAND "${TS_BUILDDIR}/test/hamming_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_homography_opencl
           COMMAND "${TS_BUILDDIR}/test/homography_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_hsv_rgb_opencl
           COMMAND "${TS_BUILDDIR}/test/hsv_rgb_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_iir_opencl
           COMMAND "${TS_BUILDDIR}/test/iir_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_imageio_opencl
           COMMAND "${TS_BUILDDIR}/test/imageio_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_index_opencl
           COMMAND "${TS_BUILDDIR}/test/index_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_info_opencl
           COMMAND "${TS_BUILDDIR}/test/info_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_inverse_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/inverse_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_iota_opencl
           COMMAND "${TS_BUILDDIR}/test/iota_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_ireduce_opencl
           COMMAND "${TS_BUILDDIR}/test/ireduce_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_jit_opencl
           COMMAND "${TS_BUILDDIR}/test/jit_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_join_opencl
           COMMAND "${TS_BUILDDIR}/test/join_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_lu_dense_opencl
           COMMAND "${TS_BUILDDIR}/test/lu_dense_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_match_template_opencl
           COMMAND "${TS_BUILDDIR}/test/match_template_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_math_opencl
           COMMAND "${TS_BUILDDIR}/test/math_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_matrix_manipulation_opencl
           COMMAND "${TS_BUILDDIR}/test/matrix_manipulation_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_mean_opencl
           COMMAND "${TS_BUILDDIR}/test/mean_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_meanshift_opencl
           COMMAND "${TS_BUILDDIR}/test/meanshift_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_medfilt_opencl
           COMMAND "${TS_BUILDDIR}/test/medfilt_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
# takes too long
#  add_test(NAME arrayfire_tests_median_opencl
#           COMMAND "${TS_BUILDDIR}/test/median_opencl"
#           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_memory_lock_opencl
           COMMAND "${TS_BUILDDIR}/test/memory_lock_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_memory_opencl
           COMMAND "${TS_BUILDDIR}/test/memory_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_missing_opencl
           COMMAND "${TS_BUILDDIR}/test/missing_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_moddims_opencl
           COMMAND "${TS_BUILDDIR}/test/moddims_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
  add_test(NAME arrayfire_tests_morph_opencl
           COMMAND "${TS_BUILDDIR}/test/morph_opencl"
           WORKING_DIRECTORY "${TS_BUILDDIR}/test")
