=== debian/changelog ===
pocl (5.0-2.1build3) noble; urgency=medium

  * No-change rebuild against libllvm16t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 00:35:55 +0100

pocl (5.0-2.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:48:19 +0000

pocl (5.0-2.1build1) noble; urgency=medium

  * No-change rebuild against libllvm16 t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 20:21:30 +0100

pocl (5.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063263

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 20:59:55 +0000

pocl (5.0-2) unstable; urgency=medium

  * Switch to llvm 16.  (Closes: #1060298)
  * Update symbols file for amd64 and i386.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Jan 2024 14:00:32 +0100

pocl (5.0-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update symbols file.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 08 Jan 2024 22:27:47 +0100

pocl (5.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Update symbols file for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 13 Dec 2023 21:15:14 +0100

pocl (4.0-3) unstable; urgency=medium

  * Perform a distro build for i386, too.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Dec 2023 16:33:19 +0100
